package dados;

import util.Data;
import util.Periodo;
import util.excel.exception.IOExcelException;
import excecoes.ReservaJaCadastradaException;
import excecoes.ReservaNaoEncontradaException;
import excecoes.ValorInvalidoException;
import negocios.CadastroReservas;

public class Quarto {
	private CadastroReservas reservas;
	private String numeroDoQuarto;
	private int vagas;
	private double valorDiaria;
	private double faturamento;
	private double faturamentoPeriodo;
	
	public Quarto(String numero, int vagas, double valor) throws ValorInvalidoException, IOExcelException{
		if(valor<=0)
			throw new ValorInvalidoException();
		else
		this.valorDiaria=valor;
		this.numeroDoQuarto=numero;
		this.vagas=vagas;
		this.faturamento=0.0;
		this.faturamentoPeriodo=0.0;
		reservas = new CadastroReservas(new RepositorioReservasArray());
	}

	public void faturarPeriodo(Data di, Data df) throws ReservaNaoEncontradaException{
		Periodo periodo = new Periodo(di, df);
		Reserva reserva = reservas.pesquisar(periodo);
	}
	
	public void faturar(int x){
		this.faturamento = faturamento + (valorDiaria*x);
	}
	
	public double getFaturamentoPeriodo(){
		return this.faturamentoPeriodo;
 	}
	
	public double getFaturamento(){
		return this.faturamento;
 	}
	
	public void setNumero(String numero){
		this.numeroDoQuarto=numero;
	}
	
	public void setVagas(int vagas){
		this.vagas=vagas;
	}
	
	public void setValor(double valor){
		this.valorDiaria=valor;
	}
	
	public String getNumero(){
		return this.numeroDoQuarto;	
	}
	
	public int getVagas(){
		return this.vagas;	
	}
	
	public double getValor(){
		return this.valorDiaria;	
	}
	
	public boolean equals(Quarto c){
		boolean resposta=false;
		if(this.getNumero().equals(c.getNumero()) &&
				this.getVagas()==c.getVagas() &&
				this.getValor()==c.getValor())
			resposta = true;
		
		return resposta;
	}
	
	public void inserirReserva(Reserva reserva) throws ReservaJaCadastradaException{
		this.reservas.inserir(reserva);
	}
	
	public void apagarReserva(Reserva reserva) throws ReservaNaoEncontradaException{
		this.reservas.remover(reserva.getPeriodo());
	}
	
	public boolean existeReserva(Periodo periodo){
		return reservas.existe(periodo);
	}
	
	public IteratorReservas getIteratorReservas(){
		return reservas.getIterator();
	}
	
		
}