package dados;

public class RepositorioQuartosArray implements RepositorioQuartos {
	private Quarto[] arrayQuartos;
	private int tamanhoArray;
	private int proximo;
	
	public RepositorioQuartosArray(){
		this.tamanhoArray=10;
		this.arrayQuartos=new Quarto[tamanhoArray];	
		this.proximo =0;	
	}
	
	private void duplicarArray(){
		tamanhoArray = tamanhoArray*2;
		Quarto[] novoArray = new Quarto[tamanhoArray];
		for(int i=0; i<proximo;i++ ) {
			novoArray[i]=arrayQuartos[i];
		}
		arrayQuartos=novoArray;
	}
	
	public void inserir(Quarto quarto){
		
		arrayQuartos[proximo]=quarto;
		proximo = proximo + 1;
		if(proximo>=tamanhoArray)
			duplicarArray();
	}
	
	public Quarto pesquisar(String numero){
		Quarto resposta = null;
		int i = 0;
		while (i<proximo && resposta==null) {
			if(arrayQuartos[i].getNumero().equals(numero))
				resposta=arrayQuartos[i];
			i = i + 1;
		}
		
		
		return resposta;
	}
	
	public void remover(String numero){
		boolean achou = false;
		int i=0;
		while (i<proximo && achou==false){
			if(arrayQuartos[i].getNumero().equals(numero)) {
				arrayQuartos[i] = null;
				if(i!=proximo-1)
					arrayQuartos[i] = arrayQuartos[proximo-1];
				proximo = proximo - 1;
				achou = true;
			}
		}
	}
	
	public void atualizar(Quarto quarto) {
		boolean achou = false;
		int i=0;
		while (i<proximo && achou==false){
			if(arrayQuartos[i].getNumero().equals(quarto.getNumero())){
				arrayQuartos[i]=quarto;
				achou = true;
			}
		}
		
	}
	
	public boolean existe(Quarto quarto) {
		boolean achou = false;
		int i=0;
		while (i<proximo && achou==false){
			if(arrayQuartos[i].getNumero().equals(quarto.getNumero()))
				achou = true;
		}
		return achou;
	}
	
	public IteratorQuartos getIterator() {
		IteratorQuartosArray iterator = new IteratorQuartosArray(arrayQuartos);
		return iterator;
	}
	
}
