package dados;

import util.Periodo;
import util.excel.ExcelWorkbook;
import util.excel.exception.IOExcelException;

public class RepositorioReservasArray implements RepositorioReservas {
	
	private Reserva [] reservas;
	private int tamanhoArray;
	private int proxPosicaoVaga;
	
	
	public RepositorioReservasArray(){
		tamanhoArray = 10;
		proxPosicaoVaga=0;
		reservas = new Reserva[tamanhoArray];
	}
	
	private void duplicarArray(){
		Reserva[] arrayNovo= new Reserva[tamanhoArray*2];
		for(int i =0; i<tamanhoArray;i++){
			arrayNovo[i]=reservas[i];
		}
		tamanhoArray = tamanhoArray*2;
		reservas = arrayNovo;
	}
		
	public void inserir(Reserva r){
			
		reservas[proxPosicaoVaga]=r;
		proxPosicaoVaga++;
		
		if(proxPosicaoVaga>=tamanhoArray)
			duplicarArray();
	}
	
	public Reserva pesquisar(Periodo p){
		Reserva resposta=null;
		int i=0;
		while(resposta==null && i<proxPosicaoVaga){
			if(reservas[i].getPeriodo().equals(p))
				{resposta = reservas[i];}
			i++;
		}
	return resposta;
	}
	
	public void remover(Periodo p){
		int i=0;
		boolean achou=false;
		while(i<proxPosicaoVaga && !achou){
			if(reservas[i].getPeriodo().equals(p))
				{reservas[i]=reservas[proxPosicaoVaga-1];
					proxPosicaoVaga=proxPosicaoVaga-1;
					achou=true;
					}
		}
	}
	
	public boolean existe(Periodo p){
		boolean resposta = false;
		int i=0;
		while(resposta==false && i<proxPosicaoVaga){
			if(p.temIntersecao(reservas[i].getPeriodo()))
				{if(p.getDataInicial().equals(reservas[i].getPeriodo().getDataFinal())
						|| p.getDataFinal().equals(reservas[i].getPeriodo().getDataInicial()))
				resposta = false;
				else resposta = true;}
			i++;
		}
		return resposta;
	}

	public IteratorReservas getIterator() {
		IteratorReservasArray iterator = new IteratorReservasArray(reservas);
		return iterator;
	}
	
}
