package gui;

import java.awt.BorderLayout;

import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;

import util.excel.exception.IOExcelException;

import dados.Quarto;

import excecoes.QuartoJaCadastradoException;
import excecoes.ValorInvalidoException;
import fachada.Fachada;

public class JanelaCadastroQuarto extends JFrame {
	
	private Fachada fachada;
	private JPanel jContentPane = null;
	private JLabel jlb_numero = null;
	private JLabel jlb_capacidade = null;
	private JLabel jlb_preco = null;
	private JTextField jtf_numero = null;
	private JTextField jtf_capacidade = null;
	private JTextField jtf_preco = null;
	private JButton jbt_cadastrar = null;
	
	/**
	 * This method initializes jtf_numero	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtf_numero() {
		if (jtf_numero == null) {
			jtf_numero = new JTextField();
			jtf_numero.setBounds(new java.awt.Rectangle(241,58,148,23));
		}
		return jtf_numero;
	}
	
	/**
	 * This method initializes jtf_capacidade	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtf_capacidade() {
		if (jtf_capacidade == null) {
			jtf_capacidade = new JTextField();
			jtf_capacidade.setBounds(new java.awt.Rectangle(241,108,148,23));
		}
		return jtf_capacidade;
	}
	
	/**
	 * This method initializes jtf_preco	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtf_preco() {
		if (jtf_preco == null) {
			jtf_preco = new JTextField();
			jtf_preco.setBounds(new java.awt.Rectangle(240,160,148,23));
		}
		return jtf_preco;
	}
	
	/**
	 * This method initializes jbt_cadastrar	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJbt_cadastrar() {
		if (jbt_cadastrar == null) {
			jbt_cadastrar = new JButton();
			jbt_cadastrar.setBounds(new java.awt.Rectangle(173,222,189,29));
			jbt_cadastrar.setText("Cadastrar");
			jbt_cadastrar.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					cadastrar();
				}
			});
		}
		return jbt_cadastrar;
	}
	
	protected void cadastrar() {
		
		
		try{
			String numero = jtf_numero.getText();
			int capacidade = Integer.parseInt(jtf_capacidade.getText());
			double preco = Integer.parseInt(jtf_preco.getText());
			Quarto quarto = new Quarto(numero, capacidade, preco);
			fachada.inserirQuarto(quarto);
			jtf_numero.setText("");
			jtf_capacidade.setText("");
			jtf_preco.setText("");
			JOptionPane.showMessageDialog(this, "Quarto cadastrado com sucesso");
		}
		catch(QuartoJaCadastradoException e){
			JOptionPane.showMessageDialog(this, e.getMessage());
		} catch(ValorInvalidoException e){
			JOptionPane.showMessageDialog(this, e.getMessage());
		} catch (IOExcelException e) {
			JOptionPane.showMessageDialog(this, e.getMessage());
		}
		
		
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		
	}
	
	/**
	 * This is the default constructor
	 */
	public JanelaCadastroQuarto() {
		super();
		initialize();
		fachada = fachada.getInstance();
	}
	
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(500, 300);
		this.setContentPane(getJContentPane());
		this.setTitle("Cadastro de Quarto");
	}
	
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jlb_preco = new JLabel();
			jlb_preco.setBounds(new java.awt.Rectangle(105,163,90,16));
			jlb_preco.setText("Preo da Diria:");
			jlb_capacidade = new JLabel();
			jlb_capacidade.setBounds(new java.awt.Rectangle(126,111,70,16));
			jlb_capacidade.setText("Capacidade:");
			jlb_numero = new JLabel();
			jlb_numero.setBounds(new java.awt.Rectangle(148,61,48,16));
			jlb_numero.setText("Nmero:");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(jlb_numero, null);
			jContentPane.add(jlb_capacidade, null);
			jContentPane.add(jlb_preco, null);
			jContentPane.add(getJtf_numero(), null);
			jContentPane.add(getJtf_capacidade(), null);
			jContentPane.add(getJtf_preco(), null);
			jContentPane.add(getJbt_cadastrar(), null);
		}
		return jContentPane;
	}
	
}
