package gui;

import java.awt.BorderLayout;

import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;

import dados.Reserva;
import excecoes.QuartoLotadoException;
import excecoes.QuartoNaoCadastradoException;
import excecoes.ReservaJaCadastradaException;

import util.Data;
import util.DataInvalidaException;
import util.Periodo;

import fachada.Fachada;

public class JanelaCadastroReserva extends JFrame {

	private String numero;
	private Fachada fachada; 
	private JPanel jContentPane = null;
	private JLabel Entrada = null;
	private JLabel Saida = null;
	private JLabel qtd_hosp = null;
	private JTextField jtf_diaEntrada = null;
	private JTextField jtf_mesEntrada = null;
	private JTextField jtf_anoEntrada = null;
	private JTextField jtf_diaSaida = null;
	private JTextField jtf_mesSaida = null;
	private JTextField jtf_anoSaida = null;
	private JTextField jtf_hospedes = null;
	private JButton jbt_cadastrar = null;

	/**
	 * This method initializes jtf_diaEntrada	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtf_diaEntrada() {
		if (jtf_diaEntrada == null) {
			jtf_diaEntrada = new JTextField();
			jtf_diaEntrada.setBounds(new java.awt.Rectangle(214,68,35,21));
		}
		return jtf_diaEntrada;
	}

	/**
	 * This method initializes jtf_mesEntrada	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtf_mesEntrada() {
		if (jtf_mesEntrada == null) {
			jtf_mesEntrada = new JTextField();
			jtf_mesEntrada.setBounds(new java.awt.Rectangle(265,68,35,21));
		}
		return jtf_mesEntrada;
	}

	/**
	 * This method initializes jtf_anoEntrada	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtf_anoEntrada() {
		if (jtf_anoEntrada == null) {
			jtf_anoEntrada = new JTextField();
			jtf_anoEntrada.setBounds(new java.awt.Rectangle(315,68,35,21));
		}
		return jtf_anoEntrada;
	}

	/**
	 * This method initializes jtf_diaSaida	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtf_diaSaida() {
		if (jtf_diaSaida == null) {
			jtf_diaSaida = new JTextField();
			jtf_diaSaida.setBounds(new java.awt.Rectangle(213,103,35,21));
		}
		return jtf_diaSaida;
	}

	/**
	 * This method initializes jtf_mesSaida	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtf_mesSaida() {
		if (jtf_mesSaida == null) {
			jtf_mesSaida = new JTextField();
			jtf_mesSaida.setBounds(new java.awt.Rectangle(265,103,35,21));
		}
		return jtf_mesSaida;
	}

	/**
	 * This method initializes jtf_anoSaida	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtf_anoSaida() {
		if (jtf_anoSaida == null) {
			jtf_anoSaida = new JTextField();
			jtf_anoSaida.setBounds(new java.awt.Rectangle(315,103,35,21));
		}
		return jtf_anoSaida;
	}

	/**
	 * This method initializes jtf_hospedes	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtf_hospedes() {
		if (jtf_hospedes == null) {
			jtf_hospedes = new JTextField();
			jtf_hospedes.setBounds(new java.awt.Rectangle(213,138,86,22));
		}
		return jtf_hospedes;
	}

	/**
	 * This method initializes jbt_cadastrar	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJbt_cadastrar() {
		if (jbt_cadastrar == null) {
			jbt_cadastrar = new JButton();
			jbt_cadastrar.setBounds(new java.awt.Rectangle(175,198,183,35));
			jbt_cadastrar.setText("Cadastrar");
			jbt_cadastrar.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					cadastrar();
				}
			});
		}
		return jbt_cadastrar;
	}

		/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

	/**
	 * This is the default constructor
	 */
	public JanelaCadastroReserva(String numeroQuarto) {
		super();
		fachada= fachada.getInstance();
		this.numero = numeroQuarto;
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(500, 300);
		this.setContentPane(getJContentPane());
		this.setTitle("Cadastrar Reserva");
		
	}

	private void cadastrar() {
		
		try {
			if(jtf_diaEntrada.getText().length()<2)
				jtf_diaEntrada.setText("0"+jtf_diaEntrada.getText());
			
			if(jtf_mesEntrada.getText().length()<2)
				jtf_mesEntrada.setText("0"+jtf_mesEntrada.getText());
			
			if(jtf_diaSaida.getText().length()<2)
				jtf_diaSaida.setText("0"+jtf_diaSaida.getText());
			
			if(jtf_mesSaida.getText().length()<2)
				jtf_mesSaida.setText("0"+jtf_mesSaida.getText());
			
			Data d1 = new Data(Integer.parseInt(jtf_diaEntrada.getText()), Integer.parseInt(jtf_mesEntrada.getText()), Integer.parseInt(jtf_anoEntrada.getText()));
			Data d2 = new Data(Integer.parseInt(jtf_diaSaida.getText()), Integer.parseInt(jtf_mesSaida.getText()), Integer.parseInt(jtf_anoSaida.getText()));
		
			Periodo p = new Periodo(d1,d2);
		
			Reserva reserva = new Reserva(p,Integer.parseInt(jtf_hospedes.getText()));
		
			fachada.inserirReserva(numero,reserva);
			JOptionPane.showMessageDialog(this,"Reserva Cadastrada com Sucesso!");
			
			jtf_diaEntrada.setText(""); 
			jtf_mesEntrada.setText("");
			jtf_anoEntrada.setText("");
			jtf_diaSaida.setText("");
			jtf_mesSaida.setText("");
			jtf_anoSaida.setText("");
			jtf_hospedes.setText("");
			
		} catch (QuartoNaoCadastradoException e) {
			JOptionPane.showMessageDialog(this, e.getMessage());
		} catch (ReservaJaCadastradaException e) {
			JOptionPane.showMessageDialog(this, e.getMessage());
		} catch (QuartoLotadoException e) {
			JOptionPane.showMessageDialog(this, e.getMessage());
		}catch (NumberFormatException e) {
			JOptionPane.showMessageDialog(this, e.getMessage());
		} catch (DataInvalidaException e) {
			JOptionPane.showMessageDialog(this, e.getMessage());
		}
		
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			qtd_hosp = new JLabel();
			qtd_hosp.setBounds(new java.awt.Rectangle(48,141,145,16));
			qtd_hosp.setText("Quantidade de Hspedes:");
			Saida = new JLabel();
			Saida.setBounds(new java.awt.Rectangle(112,105,81,16));
			Saida.setText("Data de Sada:");
			Entrada = new JLabel();
			Entrada.setBounds(new java.awt.Rectangle(100,70,93,16));
			Entrada.setText("Data de Entrada:");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(Entrada, null);
			jContentPane.add(Saida, null);
			jContentPane.add(qtd_hosp, null);
			jContentPane.add(getJtf_diaEntrada(), null);
			jContentPane.add(getJtf_mesEntrada(), null);
			jContentPane.add(getJtf_anoEntrada(), null);
			jContentPane.add(getJtf_diaSaida(), null);
			jContentPane.add(getJtf_mesSaida(), null);
			jContentPane.add(getJtf_anoSaida(), null);
			jContentPane.add(getJtf_hospedes(), null);
			jContentPane.add(getJbt_cadastrar(), null);
		}
		return jContentPane;
	}

}
