package gui;

import java.awt.BorderLayout;

import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;

import fachada.Fachada;

import util.Data;
import util.DataInvalidaException;
import util.Periodo;

public class JanelaFaturamentoPeriodo extends JFrame {

	private Fachada fachada;
	private JPanel jContentPane = null;
	private JLabel jlb_dataInicial = null;
	private JLabel jlb_dataFinal = null;
	private JLabel jlb_faturamento = null;
	private JTextField jtf_diaInicial = null;
	private JTextField jtf_mesInicial = null;
	private JTextField jtf_anoInicial = null;
	private JTextField jtf_diaFinal = null;
	private JTextField jtf_mesFinal = null;
	private JTextField jtf_anoFinal = null;
	private JTextField jtf_faturamento = null;
	private JButton jbt_pesquisar = null;

	/**
	 * This method initializes jtf_diaInicial	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtf_diaInicial() {
		if (jtf_diaInicial == null) {
			jtf_diaInicial = new JTextField();
			jtf_diaInicial.setBounds(new java.awt.Rectangle(128,28,41,22));
		}
		return jtf_diaInicial;
	}

	/**
	 * This method initializes jtf_mesInicial	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtf_mesInicial() {
		if (jtf_mesInicial == null) {
			jtf_mesInicial = new JTextField();
			jtf_mesInicial.setBounds(new java.awt.Rectangle(186,28,41,22));
		}
		return jtf_mesInicial;
	}

	/**
	 * This method initializes jtf_anoInicial	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtf_anoInicial() {
		if (jtf_anoInicial == null) {
			jtf_anoInicial = new JTextField();
			jtf_anoInicial.setBounds(new java.awt.Rectangle(246,28,41,22));
		}
		return jtf_anoInicial;
	}

	/**
	 * This method initializes jtf_diaFinal	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtf_diaFinal() {
		if (jtf_diaFinal == null) {
			jtf_diaFinal = new JTextField();
			jtf_diaFinal.setBounds(new java.awt.Rectangle(129,67,41,22));
		}
		return jtf_diaFinal;
	}

	/**
	 * This method initializes jtf_mesFinal	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtf_mesFinal() {
		if (jtf_mesFinal == null) {
			jtf_mesFinal = new JTextField();
			jtf_mesFinal.setBounds(new java.awt.Rectangle(186,67,41,22));
		}
		return jtf_mesFinal;
	}

	/**
	 * This method initializes jtf_anoFinal	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtf_anoFinal() {
		if (jtf_anoFinal == null) {
			jtf_anoFinal = new JTextField();
			jtf_anoFinal.setBounds(new java.awt.Rectangle(246,67,41,22));
		}
		return jtf_anoFinal;
	}

	/**
	 * This method initializes jtf_faturamento	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtf_faturamento() {
		if (jtf_faturamento == null) {
			jtf_faturamento = new JTextField();
			jtf_faturamento.setBounds(new java.awt.Rectangle(129,106,70,21));
			jtf_faturamento.setEditable(false);
			jtf_faturamento.setEnabled(true);
		}
		return jtf_faturamento;
	}

	/**
	 * This method initializes jbt_pesquisar	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJbt_pesquisar() {
		if (jbt_pesquisar == null) {
			jbt_pesquisar = new JButton();
			jbt_pesquisar.setBounds(new java.awt.Rectangle(131,153,92,26));
			jbt_pesquisar.setText("Pesquisar");
			jbt_pesquisar.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					pesquisar();
				}
			});
		}
		return jbt_pesquisar;
	}

	protected void pesquisar() {
	
		
		try {
			Data d1 = new Data(Integer.parseInt(jtf_diaInicial.getText()), Integer.parseInt(jtf_mesInicial.getText()), Integer.parseInt(jtf_anoInicial.getText()));
			Data d2 = new Data(Integer.parseInt(jtf_diaFinal.getText()), Integer.parseInt(jtf_mesFinal.getText()), Integer.parseInt(jtf_anoFinal.getText()));
			Periodo p = new Periodo(d1,d2);
			jtf_faturamento.setText(String.valueOf(fachada.getFaturamentoPeriodo(p)));
		} catch (NumberFormatException e) {
			JOptionPane.showMessageDialog(this, e.getMessage());
		} catch (DataInvalidaException e) {
			JOptionPane.showMessageDialog(this, e.getMessage());
		}
		
		
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

	/**
	 * This is the default constructor
	 */
	public JanelaFaturamentoPeriodo() {
		super();
		fachada = Fachada.getInstance();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(342, 226);
		this.setContentPane(getJContentPane());
		this.setTitle("Faturamento por Periodo");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jlb_dataInicial = new JLabel();
			jlb_dataInicial.setBounds(new java.awt.Rectangle(29,31,65,16));
			jlb_dataInicial.setText("Data Inicial:");
			jlb_faturamento = new JLabel();
			jlb_faturamento.setBounds(new java.awt.Rectangle(19,108,75,16));
			jlb_faturamento.setText("Faturamento:");
			jlb_dataFinal = new JLabel();
			jlb_dataFinal.setBounds(new java.awt.Rectangle(36,70,58,16));
			jlb_dataFinal.setText("Data Final:");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(jlb_dataInicial, null);
			jContentPane.add(jlb_dataFinal, null);
			jContentPane.add(jlb_faturamento, null);
			jContentPane.add(getJtf_diaInicial(), null);
			jContentPane.add(getJtf_mesInicial(), null);
			jContentPane.add(getJtf_anoInicial(), null);
			jContentPane.add(getJtf_diaFinal(), null);
			jContentPane.add(getJtf_mesFinal(), null);
			jContentPane.add(getJtf_anoFinal(), null);
			jContentPane.add(getJtf_faturamento(), null);
			jContentPane.add(getJbt_pesquisar(), null);
		}
		return jContentPane;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
