package gui;

import java.awt.BorderLayout;

import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;

import dados.Quarto;
import excecoes.QuartoNaoCadastradoException;

import fachada.Fachada;

public class JanelaFaturamentoQuarto extends JFrame {
	
	Fachada fachada;

	private JPanel jContentPane = null;
	private JLabel jl_numeroDoQuarto = null;
	private JTextField jtf_numeroDoQuarto = null;
	private JTextField jtf_faturamento = null;
	private JLabel jl_faturamento = null;
	private JButton jb_Pesquisar = null;

	/**
	 * This method initializes jtf_numeroDoQuarto	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtf_numeroDoQuarto() {
		if (jtf_numeroDoQuarto == null) {
			jtf_numeroDoQuarto = new JTextField();
			jtf_numeroDoQuarto.setBounds(new java.awt.Rectangle(142,22,44,26));
		}
		return jtf_numeroDoQuarto;
	}

	/**
	 * This method initializes jtf_faturamento	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtf_faturamento() {
		if (jtf_faturamento == null) {
			jtf_faturamento = new JTextField();
			jtf_faturamento.setBounds(new java.awt.Rectangle(142,74,72,26));
			jtf_faturamento.setEditable(false);
			jtf_faturamento.setEnabled(true);
		}
		return jtf_faturamento;
	}

	/**
	 * This method initializes jb_Pesquisar	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJb_Pesquisar() {
		if (jb_Pesquisar == null) {
			jb_Pesquisar = new JButton();
			jb_Pesquisar.setBounds(new java.awt.Rectangle(96,120,92,26));
			jb_Pesquisar.setText("Pesquisar");
			jb_Pesquisar.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					faturar();
				}
			});
		}
		return jb_Pesquisar;
	}

	protected void faturar() {
		try {
			Quarto q = fachada.procurarQuarto(jtf_numeroDoQuarto.getText());
			jtf_faturamento.setText(String.valueOf(q.getFaturamento()));
		} catch (QuartoNaoCadastradoException e) {
			JOptionPane.showMessageDialog(this, e.getMessage());
		}
				
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

	/**
	 * This is the default constructor
	 */
	public JanelaFaturamentoQuarto() {
		super();
		fachada = Fachada.getInstance();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(277, 188);
		this.setContentPane(getJContentPane());
		this.setTitle("Faturamento do Quarto");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jl_faturamento = new JLabel();
			jl_faturamento.setBounds(new java.awt.Rectangle(45,80,75,16));
			jl_faturamento.setText("Faturamento:");
			jl_numeroDoQuarto = new JLabel();
			jl_numeroDoQuarto.setBounds(new java.awt.Rectangle(17,24,108,16));
			jl_numeroDoQuarto.setText("Nmero Do Quarto:");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(jl_numeroDoQuarto, null);
			jContentPane.add(getJtf_numeroDoQuarto(), null);
			jContentPane.add(getJtf_faturamento(), null);
			jContentPane.add(jl_faturamento, null);
			jContentPane.add(getJb_Pesquisar(), null);
		}
		return jContentPane;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
