package gui;

import java.awt.BorderLayout;

import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.JButton;

import dados.IteratorReservas;
import dados.Quarto;
import dados.Reserva;
import excecoes.QuartoNaoCadastradoException;
import excecoes.ReservaNaoEncontradaException;

import fachada.Fachada;

public class JanelaPeriodo extends JFrame {

	private String numero;
	private Fachada fachada;
	private JPanel jContentPane = null;
	private JLabel jLabel = null;
	private JComboBox jcb_periodos = null;
	private JButton jbt_remover = null;
	private JButton jButton = null;

	/**
	 * This method initializes jcb_periodos	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJcb_periodos() {
		if (jcb_periodos == null) {
			jcb_periodos = new JComboBox();
			jcb_periodos.setBounds(new java.awt.Rectangle(86,43,178,24));
		}
		return jcb_periodos;
	}

	/**
	 * This method initializes jbt_remover	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJbt_remover() {
		if (jbt_remover == null) {
			jbt_remover = new JButton();
			jbt_remover.setBounds(new java.awt.Rectangle(273,43,109,24));
			jbt_remover.setText("Remover");
			jbt_remover.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
				removerReserva();
				}
			});
		}
		return jbt_remover;
	}

	protected void removerReserva() {
		Reserva reserva = this.procurarReserva();
		try {
			fachada.removerReserva(numero,reserva);
		} catch (QuartoNaoCadastradoException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ReservaNaoEncontradaException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		int index = jcb_periodos.getSelectedIndex();
		jcb_periodos.remove(index);
		
		
	}

	private Reserva procurarReserva() {
		String d1 = jcb_periodos.getSelectedItem().toString().substring(0,9);
		String d2 = jcb_periodos.getSelectedItem().toString().substring(13,22);
		return null;
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setBounds(new java.awt.Rectangle(118,103,114,29));
			jButton.setText("OK");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
				sair();
				}
			});
		}
		return jButton;
	}

	protected void sair() {
		this.setVisible(false);
		
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

	/**
	 * This is the default constructor
	 */
	public JanelaPeriodo(String numero) {
		super();
		fachada = fachada.getInstance();
		this.numero = numero;
		initialize(numero);
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize(String numero) {
		this.setSize(400, 200);
		this.setContentPane(getJContentPane());
		this.setTitle("Selecione o Perodo");
		
		try {
			Quarto quarto = fachada.procurarQuarto(numero);
			IteratorReservas iteratorReservas = quarto.getIteratorReservas();
			Reserva reserva = null;
			while(iteratorReservas.hasNext()){
				reserva = iteratorReservas.next();
				jcb_periodos.addItem(reserva.getPeriodo().toString());
		}
		}catch (QuartoNaoCadastradoException e) {
			JOptionPane.showMessageDialog(this,e.getMessage());
		}
		
		
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel = new JLabel();
			jLabel.setBounds(new java.awt.Rectangle(15,47,51,16));
			jLabel.setText("Periodos");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(jLabel, null);
			jContentPane.add(getJcb_periodos(), null);
			jContentPane.add(getJbt_remover(), null);
			jContentPane.add(getJButton(), null);
		}
		return jContentPane;
	}

}  //  @jve:decl-index=0:visual-constraint="70,34"
