package gui;

import java.awt.BorderLayout;

import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JMenuBar;
import javax.swing.JToolBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JLabel;
import javax.swing.ImageIcon;

import util.DataEmFormatoInvalidoException;
import util.excel.exception.CellNumberFormatException;
import util.excel.exception.CellStringFormatException;
import util.excel.exception.IOExcelException;
import util.excel.exception.NotDefinedCellException;
import util.excel.exception.NotDefinedRowException;
import util.excel.exception.SheetNotFoundException;

import excecoes.QuartoLotadoException;
import excecoes.QuartoNaoCadastradoException;
import excecoes.ReservaJaCadastradaException;
import fachada.Fachada;

public class JanelaPrincipal extends JFrame {
	
	Fachada fachada;

	private JPanel jContentPane = null;
	private JMenuBar menuPrincipal = null;
	private JMenu MenuAcoes = null;
	private JMenu MenuReservas = null;
	private JMenuItem MenuItemSair = null;
	private JMenuItem MenuFaturamentoPeriodo = null;
	private JMenuItem MenuFaturamentoQuarto = null;
	private JMenuItem MenuInserirEspecial = null;
	private JMenu financas=null;
	private JMenu gerenciarQuartos =null;
	private JMenuItem MenuItemNovoQuarto=null;
	private JMenuItem MenuItemPesquisarQuarto=null;
	private JMenuItem MenuItemQuartosDisponiveis=null;
	//Fachada fachada;
	private JLabel imagem = null;
	//  @jve:decl-index=0:visual-constraint="7,64"
	/**
	 * This method initializes menuPrincipal	
	 * 	
	 * @return javax.swing.JMenuBar	
	 */
	private JMenuBar getMenuPrincipal() {
		if (menuPrincipal == null) {
			menuPrincipal = new JMenuBar();
			menuPrincipal.add(getMenuAcoes());
			menuPrincipal.add(getMenuReservas());
		}
		return menuPrincipal;
	}

	/**
	 * This method initializes MenuAcoes	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getMenuAcoes() {
		if (MenuAcoes == null) {
			MenuAcoes = new JMenu();
			MenuAcoes.setText("Aes");
			
			MenuAcoes.add(getGerenciarQuartos());
			MenuAcoes.add(getFinancas());
			MenuAcoes.add(getMenuItemSair());
			MenuAcoes.insertSeparator(2);
			
		}
		return MenuAcoes;
	}

	private JMenu getMenuReservas() {
		if (MenuReservas == null) {
			MenuReservas = new JMenu();
			MenuReservas.setText("Reservas");
			
			MenuReservas.add(getMenuInserirEspecial());

			
		}
		return MenuReservas;
	}
	/**
	 * This method initializes financas	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getGerenciarQuartos() {
		if (gerenciarQuartos == null) {
			gerenciarQuartos = new JMenu();
			gerenciarQuartos.setText("Gerenciar Quartos");
			gerenciarQuartos.add(getMenuItemNovoQuarto());
			gerenciarQuartos.add(getMenuItemPesquisarQuarto());
			gerenciarQuartos.add(getMenuItemQuartosDisponiveis());
		}
		return gerenciarQuartos;
	}
	
	/**
	 * This method initializes financas	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getFinancas() {
		if (financas == null) {
			financas = new JMenu();
			financas.setText("Financas");
			financas.add(getMenuFaturamentoQuarto());
			financas.add(getMenuFaturamentoPeriodo());
		}
		return financas;
	}




	/**
	 * This method initializes MenuItemSair	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getMenuItemSair() {
		if (MenuItemSair == null) {
			MenuItemSair = new JMenuItem();
			MenuItemSair.setText("Sair");
			MenuItemSair.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
				sair();
				}
			});
		}
		return MenuItemSair;
	}
	
	protected void sair() {
		System.exit(getDefaultCloseOperation());
		
	}

	private JMenuItem getMenuInserirEspecial() {
		if (MenuInserirEspecial == null) {
			MenuInserirEspecial = new JMenuItem();
			MenuInserirEspecial.setText("Inserir Especial");
			MenuInserirEspecial.addActionListener(new java.awt.event.ActionListener() {   
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					inserirEspecial();
					}
			
			});
		}
		return MenuInserirEspecial;
	}
	
	protected void inserirEspecial() {
		try {
			fachada.inserirEspecialmente("./negocios/Reservas.xls");
			JOptionPane.showMessageDialog(this, "Reservas Inseridas");
		} catch (IOExcelException e) {
			JOptionPane.showMessageDialog(this, e.getMessage());
		} catch (SheetNotFoundException e) {
			JOptionPane.showMessageDialog(this, e.getMessage());
		} catch (NotDefinedRowException e) {
			JOptionPane.showMessageDialog(this, e.getMessage());
		} catch (NotDefinedCellException e) {
			JOptionPane.showMessageDialog(this, e.getMessage());
		} catch (CellNumberFormatException e) {
			JOptionPane.showMessageDialog(this, e.getMessage());
		} catch (CellStringFormatException e) {
			JOptionPane.showMessageDialog(this, e.getMessage());
		} catch (DataEmFormatoInvalidoException e) {
			JOptionPane.showMessageDialog(this, e.getMessage());
		} catch (QuartoNaoCadastradoException e) {
			JOptionPane.showMessageDialog(this, e.getMessage());
		} catch (ReservaJaCadastradaException e) {
			JOptionPane.showMessageDialog(this, e.getMessage());
		} catch (QuartoLotadoException e) {
			JOptionPane.showMessageDialog(this, e.getMessage());
		}
		
	}

	/**
	 * This method initializes MenuItemNovoQuarto	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getMenuItemNovoQuarto() {
		if (MenuItemNovoQuarto == null) {
			MenuItemNovoQuarto = new JMenuItem();
			MenuItemNovoQuarto.setText("Novo Quarto");
			MenuItemNovoQuarto.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					abreJanelaCadastroQuarto();
				}
			});
		}
		return MenuItemNovoQuarto;
	}
	
	protected void abreJanelaCadastroQuarto() {
		JanelaCadastroQuarto frame = new JanelaCadastroQuarto();
		frame.setLocation(this.getX(), this.getY());
		frame.setVisible(true);
		
	}

	private JMenuItem getMenuFaturamentoQuarto() {
		if (MenuFaturamentoQuarto == null) {
			MenuFaturamentoQuarto = new JMenuItem();
			MenuFaturamentoQuarto.setText("Faturamento por Quarto");
			MenuFaturamentoQuarto.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					abreJanelaFaturarQuarto();
				}
			});
		}
		return MenuFaturamentoQuarto;
	}
	
	protected void abreJanelaFaturarQuarto() {
		JanelaFaturamentoQuarto janela = new JanelaFaturamentoQuarto();
		janela.setVisible(true);
	}

	private JMenuItem getMenuFaturamentoPeriodo() {
		if (MenuFaturamentoPeriodo == null) {
			MenuFaturamentoPeriodo = new JMenuItem();
			MenuFaturamentoPeriodo.setText("Faturamento por Periodo");
			MenuFaturamentoPeriodo.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					abrirFaturamentoPeriodo();
				}
			});
		}
		return MenuFaturamentoPeriodo;
	}
	
	protected void abrirFaturamentoPeriodo() {
		JanelaFaturamentoPeriodo janela = new JanelaFaturamentoPeriodo();
		janela.setVisible(true);
		
	}

	private JMenuItem getMenuItemPesquisarQuarto() {
		if (MenuItemPesquisarQuarto == null) {
			MenuItemPesquisarQuarto = new JMenuItem();
			MenuItemPesquisarQuarto.setText("Pesquisar Quarto");
			MenuItemPesquisarQuarto.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					abreJanelaPesquisaQuarto();
				}
			});
		}
		return MenuItemPesquisarQuarto;
	}
	
		protected void abreJanelaPesquisaQuarto() {
		JanelaPesquisaQuarto frame = new JanelaPesquisaQuarto();
		frame.setLocation(this.getX(), this.getY());
		frame.setVisible(true);
		
	}

	private JMenuItem getMenuItemQuartosDisponiveis() {
		if (MenuItemQuartosDisponiveis == null) {
			MenuItemQuartosDisponiveis = new JMenuItem();
			MenuItemQuartosDisponiveis.setText("Quartos Disponiveis");
			MenuItemQuartosDisponiveis
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							mostrarQuartosDisponiveis();
						}
					});
		}
		return MenuItemQuartosDisponiveis;
	}
	

	protected void mostrarQuartosDisponiveis() {
		JanelaQuartosDisponiveis frame = new JanelaQuartosDisponiveis();
		frame.setLocation(this.getX(), this.getY());
		frame.setVisible(true);
		
	}

	public static void main(String[] args) {
		JanelaPrincipal teste = new JanelaPrincipal();

	}

	/**
	 * This is the default constructor
	 */
	public JanelaPrincipal() {
		super();
		fachada = Fachada.getInstance();
		initialize();
		//Fachada fachada = fachada.getInstance();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(500, 300);
		this.setResizable(false);
		this.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
		this.setJMenuBar(getMenuPrincipal());
		this.setContentPane(getJContentPane());
		this.setTitle("Gerenciamento de Pousada");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			imagem = new JLabel();
			imagem.setText("");
			imagem.setSize(new java.awt.Dimension(500,300));
			imagem.setIcon(new ImageIcon(getClass().getResource("/gui/pousada02.jpg")));
			imagem.setLocation(new java.awt.Point(0,0));
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(imagem, null);
		}
		return jContentPane;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
