package gui;

import java.awt.BorderLayout;

import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;

import dados.Quarto;
import excecoes.QuartoNaoCadastradoException;

import fachada.Fachada;

public class JanelaQuarto extends JFrame {

	private JPanel jContentPane = null;
	private JLabel jlb_numero = null;
	private JLabel Capacidade = null;
	private JLabel valoe = null;
	private JTextField jtf_numero = null;
	private JTextField jtf_capacidade = null;
	private JTextField jtf_valor = null;
	private JButton jbt_CadastrarReserva = null;
	private JButton jbt_VerReservas = null;
	private JButton jbt_apagar = null;
	private Fachada fachada;
	/**
	 * This method initializes jtf_numero	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtf_numero() {
		if (jtf_numero == null) {
			jtf_numero = new JTextField();
			jtf_numero.setBounds(new java.awt.Rectangle(227,45,165,25));
			jtf_numero.setEditable(false);
		}
		return jtf_numero;
	}

	/**
	 * This method initializes jtf_capacidade	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtf_capacidade() {
		if (jtf_capacidade == null) {
			jtf_capacidade = new JTextField();
			jtf_capacidade.setBounds(new java.awt.Rectangle(227,81,165,25));
			jtf_capacidade.setEditable(false);
		}
		return jtf_capacidade;
	}

	/**
	 * This method initializes jtf_valor	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJtf_valor() {
		if (jtf_valor == null) {
			jtf_valor = new JTextField();
			jtf_valor.setBounds(new java.awt.Rectangle(227,126,165,25));
			jtf_valor.setEditable(false);
		}
		return jtf_valor;
	}

	/**
	 * This method initializes jbt_CadastrarReserva	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJbt_CadastrarReserva() {
		if (jbt_CadastrarReserva == null) {
			jbt_CadastrarReserva = new JButton();
			jbt_CadastrarReserva.setBounds(new java.awt.Rectangle(17,213,141,26));
			jbt_CadastrarReserva.setText("Cadastrar Reserva");
			jbt_CadastrarReserva.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					cadastrarReserva();
				}
			});
		}
		return jbt_CadastrarReserva;
	}

	protected void cadastrarReserva() {
		JanelaCadastroReserva janela = new JanelaCadastroReserva(jtf_numero.getText());
		janela.setVisible(true);
	}

	/**
	 * This method initializes jbt_VerReservas	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJbt_VerReservas() {
		if (jbt_VerReservas == null) {
			jbt_VerReservas = new JButton();
			jbt_VerReservas.setBounds(new java.awt.Rectangle(175,213,141,26));
			jbt_VerReservas.setText("Ver Reservas");
			jbt_VerReservas.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					abreJanelaVerReservas();
				}
			});
		}
		return jbt_VerReservas;
	}

	protected void abreJanelaVerReservas() {
		JanelaPeriodo janela = new JanelaPeriodo(jtf_numero.getText());
		janela.setLocation(this.getX(), this.getY());
		janela.setVisible(true);
		
	}

	/**
	 * This method initializes jbt_apagar	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJbt_apagar() {
		if (jbt_apagar == null) {
			jbt_apagar = new JButton();
			jbt_apagar.setBounds(new java.awt.Rectangle(333,213,141,26));
			jbt_apagar.setText("Remover");
			jbt_apagar.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					removerQuarto();
				}
			});
		}
		return jbt_apagar;
	}

	protected void removerQuarto() {
		try {
			fachada.removerQuarto(jtf_numero.getText());
			JOptionPane.showMessageDialog(this,"Quarto Removido!");
			jbt_CadastrarReserva.setEnabled(false);
			jbt_VerReservas.setEnabled(false);
			jbt_apagar.setEnabled(false);
			jtf_capacidade.setText("");
			jtf_numero.setText("");
			jtf_valor.setText("");
			this.setVisible(false);
			
		} catch (QuartoNaoCadastradoException e) {
			JOptionPane.showMessageDialog(this,e.getMessage());
		}
		
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

	/**
	 * This is the default constructor
	 * @throws QuartoNaoCadastradoException 
	 */
	public JanelaQuarto(String numero) throws QuartoNaoCadastradoException {
		super();
		fachada = Fachada.getInstance();
		initialize(numero);
		
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 * @throws QuartoNaoCadastradoException 
	 */
	private void initialize(String numero)  {
		this.setSize(500, 300);
		this.setContentPane(getJContentPane());
		this.setTitle("Quarto");
		this.jtf_numero.setText(numero);
		
		Quarto quarto;
		try {
			quarto = fachada.procurarQuarto(numero);
			this.jtf_capacidade.setText(String.valueOf(quarto.getVagas()));
			this.jtf_valor.setText(String.valueOf(quarto.getValor()));
			this.setVisible(true);
		} catch (QuartoNaoCadastradoException e) {
			JOptionPane.showMessageDialog(this, e.getMessage());
			this.setVisible(false);
		}
		
		
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			valoe = new JLabel();
			valoe.setBounds(new java.awt.Rectangle(93,131,83,16));
			valoe.setText("Valor da Diaria");
			Capacidade = new JLabel();
			Capacidade.setBounds(new java.awt.Rectangle(109,85,67,16));
			Capacidade.setText("Capacidade");
			jlb_numero = new JLabel();
			jlb_numero.setBounds(new java.awt.Rectangle(69,46,107,16));
			jlb_numero.setText("Numero do Quarto:");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(jlb_numero, null);
			jContentPane.add(Capacidade, null);
			jContentPane.add(valoe, null);
			jContentPane.add(getJtf_numero(), null);
			jContentPane.add(getJtf_capacidade(), null);
			jContentPane.add(getJtf_valor(), null);
			jContentPane.add(getJbt_CadastrarReserva(), null);
			jContentPane.add(getJbt_VerReservas(), null);
			jContentPane.add(getJbt_apagar(), null);
		}
		return jContentPane;
	}

}  //  @jve:decl-index=0:visual-constraint="78,10"
