package gui;
import java.awt.BorderLayout;

import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JComboBox;

import dados.IteratorQuartos;
import dados.Quarto;

import util.Data;
import util.DataInvalidaException;
import util.Periodo;

import fachada.Fachada;

public class JanelaQuartosDisponiveis extends JFrame {

	private Fachada fachada;
	private JPanel jContentPane = null;
	private JLabel lb_Entrada = null;
	private JLabel lb_Saida = null;
	private JTextField tf_diaEntrada = null;
	private JTextField tf_mesEntrada = null;
	private JTextField tf_anoEntrada = null;
	private JTextField tf_diaSaida = null;
	private JTextField tf_mesSaida = null;
	private JTextField tf_anoSaida = null;
	private JLabel lv_vagas = null;
	private JTextField tf_vagas = null;
	private JButton bt_buscar = null;
	private JComboBox cb_quartos = null;

	/**
	 * This method initializes tf_diaEntrada	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTf_diaEntrada() {
		if (tf_diaEntrada == null) {
			tf_diaEntrada = new JTextField();
			tf_diaEntrada.setBounds(new java.awt.Rectangle(139,29,31,23));
		}
		return tf_diaEntrada;
	}

	/**
	 * This method initializes tf_mesEntrada	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTf_mesEntrada() {
		if (tf_mesEntrada == null) {
			tf_mesEntrada = new JTextField();
			tf_mesEntrada.setBounds(new java.awt.Rectangle(181,29,31,23));
		}
		return tf_mesEntrada;
	}

	/**
	 * This method initializes tf_anoEntrada	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTf_anoEntrada() {
		if (tf_anoEntrada == null) {
			tf_anoEntrada = new JTextField();
			tf_anoEntrada.setBounds(new java.awt.Rectangle(224,29,40,23));
		}
		return tf_anoEntrada;
	}

	/**
	 * This method initializes tf_diaSaida	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTf_diaSaida() {
		if (tf_diaSaida == null) {
			tf_diaSaida = new JTextField();
			tf_diaSaida.setBounds(new java.awt.Rectangle(139,63,31,23));
		}
		return tf_diaSaida;
	}

	/**
	 * This method initializes tf_mesSaida	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTf_mesSaida() {
		if (tf_mesSaida == null) {
			tf_mesSaida = new JTextField();
			tf_mesSaida.setBounds(new java.awt.Rectangle(181,63,31,23));
		}
		return tf_mesSaida;
	}

	/**
	 * This method initializes tf_anoSaida	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTf_anoSaida() {
		if (tf_anoSaida == null) {
			tf_anoSaida = new JTextField();
			tf_anoSaida.setBounds(new java.awt.Rectangle(224,63,40,23));
		}
		return tf_anoSaida;
	}

	/**
	 * This method initializes tf_vagas	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTf_vagas() {
		if (tf_vagas == null) {
			tf_vagas = new JTextField();
			tf_vagas.setBounds(new java.awt.Rectangle(139,93,74,23));
		}
		return tf_vagas;
	}

	/**
	 * This method initializes bt_buscar	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBt_buscar() {
		if (bt_buscar == null) {
			bt_buscar = new JButton();
			bt_buscar.setBounds(new java.awt.Rectangle(84,128,116,36));
			bt_buscar.setText("Buscar");
			bt_buscar.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					preencherQuartos();
				}
			});
		}
		return bt_buscar;
	}

	protected void preencherQuartos() {
		
		
		try {
			
			Data d1 = new Data(Integer.parseInt(tf_diaEntrada.getText()), Integer.parseInt(tf_mesEntrada.getText()), Integer.parseInt(tf_anoEntrada.getText()));
			Data d2 = new Data(Integer.parseInt(tf_diaSaida.getText()), Integer.parseInt(tf_mesSaida.getText()), Integer.parseInt(tf_anoSaida.getText()));
			Periodo periodo = new Periodo(d1,d2);
			int qtd = Integer.parseInt(tf_vagas.getText());
			
			Quarto[] quartos = fachada.procurarQuartosDisponiveis(periodo, qtd);
			int i=0;
			if(quartos[0]==null)
			{	tf_anoEntrada.setText("");
				tf_anoSaida.setText("");
				tf_diaEntrada.setText("");
				tf_diaSaida.setText("");
				tf_mesEntrada.setText("");
				tf_mesSaida.setText("");
				tf_vagas.setText("");
				cb_quartos.removeAllItems();
			
			
			JOptionPane.showMessageDialog(this, "Sem quartos disponiveis");
			}
			else {
				while(i<quartos.length && quartos[i]!=null){
					cb_quartos.addItem("Quarto "+quartos[i].getNumero() + " - " + quartos[i].getVagas() + " vagas");
					i++;
				}
			}
		} catch (NumberFormatException e) {
			JOptionPane.showMessageDialog(this, e.getMessage());
		} catch (DataInvalidaException e) {
			JOptionPane.showMessageDialog(this, e.getMessage());
		}

		
	}

	/**
	 * This method initializes cb_quartos	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getCb_quartos() {
		if (cb_quartos == null) {
			cb_quartos = new JComboBox();
			cb_quartos.setBounds(new java.awt.Rectangle(292,27,162,27));
		}
		return cb_quartos;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

	/**
	 * This is the default constructor
	 */
	public JanelaQuartosDisponiveis() {
		super();
		fachada = fachada.getInstance();
		initialize();
		
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(479, 200);
		this.setContentPane(getJContentPane());
		this.setTitle("Quartos Disponiveis");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			lv_vagas = new JLabel();
			lv_vagas.setBounds(new java.awt.Rectangle(23,96,102,16));
			lv_vagas.setText("Vagas Desejadas:");
			lb_Saida = new JLabel();
			lb_Saida.setBounds(new java.awt.Rectangle(44,66,81,16));
			lb_Saida.setText("Data de Saida:");
			lb_Entrada = new JLabel();
			lb_Entrada.setBounds(new java.awt.Rectangle(32,32,93,16));
			lb_Entrada.setText("Data de Entrada:");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(lb_Entrada, null);
			jContentPane.add(lb_Saida, null);
			jContentPane.add(getTf_diaEntrada(), null);
			jContentPane.add(getTf_mesEntrada(), null);
			jContentPane.add(getTf_anoEntrada(), null);
			jContentPane.add(getTf_diaSaida(), null);
			jContentPane.add(getTf_mesSaida(), null);
			jContentPane.add(getTf_anoSaida(), null);
			jContentPane.add(lv_vagas, null);
			jContentPane.add(getTf_vagas(), null);
			jContentPane.add(getBt_buscar(), null);
			jContentPane.add(getCb_quartos(), null);
		}
		return jContentPane;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
