package negocios;

import util.Periodo;
import util.excel.ExcelWorkbook;
import util.excel.exception.IOExcelException;
import dados.IteratorQuartos;
import dados.IteratorReservas;
import dados.RepositorioReservas;
import dados.RepositorioReservasArray;
import dados.Reserva;
import excecoes.ReservaJaCadastradaException;
import excecoes.ReservaNaoEncontradaException;

public class CadastroReservas {

	private RepositorioReservas servicosReservas;
	
	
	public CadastroReservas(RepositorioReservasArray quartos) throws IOExcelException {
		servicosReservas = quartos;
		
	}
	
	public void inserir(Reserva r) throws ReservaJaCadastradaException{
			if(!servicosReservas.existe(r.getPeriodo()))
			servicosReservas.inserir(r);
			else throw new ReservaJaCadastradaException();
	
		}
	
	public void remover(Periodo p) throws ReservaNaoEncontradaException{
		if(servicosReservas.existe(p))
		servicosReservas.remover(p);
		else throw new ReservaNaoEncontradaException();
		
	}

	public Reserva pesquisar(Periodo p) throws ReservaNaoEncontradaException{
		Reserva resposta = servicosReservas.pesquisar(p);
		if(resposta!=null) return resposta;
		else throw new ReservaNaoEncontradaException();
	}
	
	public boolean existe(Periodo periodo){
		return servicosReservas.existe(periodo);
	}
	
	public IteratorReservas getIterator(){
		return servicosReservas.getIterator();
	}
}
