package util.excel;

import org.apache.poi.hssf.usermodel.HSSFCell;

import util.excel.exception.CellNumberFormatException;
import util.excel.exception.CellStringFormatException;

public class ExcelCell {


       private HSSFCell hssfCell;

       public ExcelCell (HSSFCell hssfCell) {
              this.setHSSFCell (hssfCell);
       }

       protected void setHSSFCell (HSSFCell hssfCell) {
            
            if (hssfCell != null) {
                this.hssfCell = hssfCell;
            } else {
            	throw new IllegalArgumentException("A celula passada eh nula");
            }
            
        }

        public double getNumericCellValue () throws CellNumberFormatException {
            double ret = 0.0;

            try {
                ret = this.hssfCell.getNumericCellValue ();
            } catch (Exception e) {
            	throw new CellNumberFormatException("O contedo da clula n "+this.hssfCell.getCellNum()+" no pode ser convertida em um numero");
            }

            return ret;
        }

        public String getStringCellValue () throws CellStringFormatException{
            String ret = "";

            try {
                ret = this.hssfCell.getStringCellValue ();
            } catch (Exception e) {
                throw new CellStringFormatException("O contedo da clula n "+this.hssfCell.getCellNum()+" no pode ser convertida em String");
            }

            return ret;
        }

}

